<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaymentMethodFee ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPaymentMethodFee
 * @subpackage Arrays
 */
class ArrayOfPaymentMethodFee extends AbstractStructArrayBase
{
    /**
     * The PaymentMethodFee
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PaymentMethodFee[]
     */
    public $PaymentMethodFee;
    /**
     * Constructor method for ArrayOfPaymentMethodFee
     * @uses ArrayOfPaymentMethodFee::setPaymentMethodFee()
     * @param \StructType\PaymentMethodFee[] $paymentMethodFee
     */
    public function __construct(array $paymentMethodFee = array())
    {
        $this
            ->setPaymentMethodFee($paymentMethodFee);
    }
    /**
     * Get PaymentMethodFee value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PaymentMethodFee[]|null
     */
    public function getPaymentMethodFee()
    {
        return isset($this->PaymentMethodFee) ? $this->PaymentMethodFee : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentMethodFee method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentMethodFee method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentMethodFeeForArrayConstraintsFromSetPaymentMethodFee(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPaymentMethodFeePaymentMethodFeeItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaymentMethodFeePaymentMethodFeeItem instanceof \StructType\PaymentMethodFee) {
                $invalidValues[] = is_object($arrayOfPaymentMethodFeePaymentMethodFeeItem) ? get_class($arrayOfPaymentMethodFeePaymentMethodFeeItem) : sprintf('%s(%s)', gettype($arrayOfPaymentMethodFeePaymentMethodFeeItem), var_export($arrayOfPaymentMethodFeePaymentMethodFeeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentMethodFee property can only contain items of type \StructType\PaymentMethodFee, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentMethodFee value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMethodFee[] $paymentMethodFee
     * @return \ArrayType\ArrayOfPaymentMethodFee
     */
    public function setPaymentMethodFee(array $paymentMethodFee = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentMethodFeeArrayErrorMessage = self::validatePaymentMethodFeeForArrayConstraintsFromSetPaymentMethodFee($paymentMethodFee))) {
            throw new \InvalidArgumentException($paymentMethodFeeArrayErrorMessage, __LINE__);
        }
        if (is_null($paymentMethodFee) || (is_array($paymentMethodFee) && empty($paymentMethodFee))) {
            unset($this->PaymentMethodFee);
        } else {
            $this->PaymentMethodFee = $paymentMethodFee;
        }
        return $this;
    }
    /**
     * Add item to PaymentMethodFee value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMethodFee $item
     * @return \ArrayType\ArrayOfPaymentMethodFee
     */
    public function addToPaymentMethodFee(\StructType\PaymentMethodFee $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaymentMethodFee) {
            throw new \InvalidArgumentException(sprintf('The PaymentMethodFee property can only contain items of type \StructType\PaymentMethodFee, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentMethodFee[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PaymentMethodFee|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PaymentMethodFee|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PaymentMethodFee|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PaymentMethodFee|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PaymentMethodFee|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentMethodFee
     */
    public function getAttributeName()
    {
        return 'PaymentMethodFee';
    }
}
