<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaymentToAssessFee ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPaymentToAssessFee
 * @subpackage Arrays
 */
class ArrayOfPaymentToAssessFee extends AbstractStructArrayBase
{
    /**
     * The PaymentToAssessFee
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PaymentToAssessFee[]
     */
    public $PaymentToAssessFee;
    /**
     * Constructor method for ArrayOfPaymentToAssessFee
     * @uses ArrayOfPaymentToAssessFee::setPaymentToAssessFee()
     * @param \StructType\PaymentToAssessFee[] $paymentToAssessFee
     */
    public function __construct(array $paymentToAssessFee = array())
    {
        $this
            ->setPaymentToAssessFee($paymentToAssessFee);
    }
    /**
     * Get PaymentToAssessFee value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PaymentToAssessFee[]|null
     */
    public function getPaymentToAssessFee()
    {
        return isset($this->PaymentToAssessFee) ? $this->PaymentToAssessFee : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentToAssessFee method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentToAssessFee method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentToAssessFeeForArrayConstraintsFromSetPaymentToAssessFee(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPaymentToAssessFeePaymentToAssessFeeItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaymentToAssessFeePaymentToAssessFeeItem instanceof \StructType\PaymentToAssessFee) {
                $invalidValues[] = is_object($arrayOfPaymentToAssessFeePaymentToAssessFeeItem) ? get_class($arrayOfPaymentToAssessFeePaymentToAssessFeeItem) : sprintf('%s(%s)', gettype($arrayOfPaymentToAssessFeePaymentToAssessFeeItem), var_export($arrayOfPaymentToAssessFeePaymentToAssessFeeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentToAssessFee property can only contain items of type \StructType\PaymentToAssessFee, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentToAssessFee value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentToAssessFee[] $paymentToAssessFee
     * @return \ArrayType\ArrayOfPaymentToAssessFee
     */
    public function setPaymentToAssessFee(array $paymentToAssessFee = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentToAssessFeeArrayErrorMessage = self::validatePaymentToAssessFeeForArrayConstraintsFromSetPaymentToAssessFee($paymentToAssessFee))) {
            throw new \InvalidArgumentException($paymentToAssessFeeArrayErrorMessage, __LINE__);
        }
        if (is_null($paymentToAssessFee) || (is_array($paymentToAssessFee) && empty($paymentToAssessFee))) {
            unset($this->PaymentToAssessFee);
        } else {
            $this->PaymentToAssessFee = $paymentToAssessFee;
        }
        return $this;
    }
    /**
     * Add item to PaymentToAssessFee value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentToAssessFee $item
     * @return \ArrayType\ArrayOfPaymentToAssessFee
     */
    public function addToPaymentToAssessFee(\StructType\PaymentToAssessFee $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaymentToAssessFee) {
            throw new \InvalidArgumentException(sprintf('The PaymentToAssessFee property can only contain items of type \StructType\PaymentToAssessFee, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentToAssessFee[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PaymentToAssessFee|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PaymentToAssessFee|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PaymentToAssessFee|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PaymentToAssessFee|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PaymentToAssessFee|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentToAssessFee
     */
    public function getAttributeName()
    {
        return 'PaymentToAssessFee';
    }
}
