<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Remove ServiceType
 * @subpackage Services
 */
class Remove extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named RemoveInSessionPaymentFees
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\RemoveInSessionPaymentFees $parameters
     * @return \StructType\RemoveInSessionPaymentFeesResponse|bool
     */
    public function RemoveInSessionPaymentFees(\StructType\RemoveInSessionPaymentFees $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RemoveInSessionPaymentFees($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * RemoveInSessionAgencyTransactionFees
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\RemoveInSessionAgencyTransactionFees $parameters
     * @return \StructType\RemoveInSessionAgencyTransactionFeesResponse|bool
     */
    public function RemoveInSessionAgencyTransactionFees(\StructType\RemoveInSessionAgencyTransactionFees $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RemoveInSessionAgencyTransactionFees($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\RemoveInSessionAgencyTransactionFeesResponse|\StructType\RemoveInSessionPaymentFeesResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
