<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Retrieve ServiceType
 * @subpackage Services
 */
class Retrieve extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named RetrievePaymentMethodsFees
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\RetrievePaymentMethodsFees $parameters
     * @return \StructType\RetrievePaymentMethodsFeesResponse|bool
     */
    public function RetrievePaymentMethodsFees(\StructType\RetrievePaymentMethodsFees $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->RetrievePaymentMethodsFees($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\RetrievePaymentMethodsFeesResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
