<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RetrievePaymentMethodsFees StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RetrievePaymentMethodsFees
 * @subpackage Structs
 */
class RetrievePaymentMethodsFees extends TransactionInfo
{
    /**
     * The RetrievePaymentMethodsFeesRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetrievePaymentMethodsFees
     */
    public $RetrievePaymentMethodsFeesRequest;
    /**
     * The PaymentMethodTypes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $PaymentMethodTypes;
    /**
     * The PaymentMethods
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfEnumerations_PaymentMethodTypes
     */
    public $PaymentMethods;
    /**
     * Constructor method for RetrievePaymentMethodsFees
     * @uses RetrievePaymentMethodsFees::setRetrievePaymentMethodsFeesRequest()
     * @uses RetrievePaymentMethodsFees::setPaymentMethodTypes()
     * @uses RetrievePaymentMethodsFees::setPaymentMethods()
     * @param \StructType\RetrievePaymentMethodsFees $retrievePaymentMethodsFeesRequest
     * @param \ArrayType\ArrayOfstring $paymentMethodTypes
     * @param \ArrayType\ArrayOfEnumerations_PaymentMethodTypes $paymentMethods
     */
    public function __construct(\StructType\RetrievePaymentMethodsFees $retrievePaymentMethodsFeesRequest = null, \ArrayType\ArrayOfstring $paymentMethodTypes = null, \ArrayType\ArrayOfEnumerations_PaymentMethodTypes $paymentMethods = null)
    {
        $this
            ->setRetrievePaymentMethodsFeesRequest($retrievePaymentMethodsFeesRequest)
            ->setPaymentMethodTypes($paymentMethodTypes)
            ->setPaymentMethods($paymentMethods);
    }
    /**
     * Get RetrievePaymentMethodsFeesRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetrievePaymentMethodsFees|null
     */
    public function getRetrievePaymentMethodsFeesRequest()
    {
        return isset($this->RetrievePaymentMethodsFeesRequest) ? $this->RetrievePaymentMethodsFeesRequest : null;
    }
    /**
     * Set RetrievePaymentMethodsFeesRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\RetrievePaymentMethodsFees $retrievePaymentMethodsFeesRequest
     * @return \StructType\RetrievePaymentMethodsFees
     */
    public function setRetrievePaymentMethodsFeesRequest(\StructType\RetrievePaymentMethodsFees $retrievePaymentMethodsFeesRequest = null)
    {
        if (is_null($retrievePaymentMethodsFeesRequest) || (is_array($retrievePaymentMethodsFeesRequest) && empty($retrievePaymentMethodsFeesRequest))) {
            unset($this->RetrievePaymentMethodsFeesRequest);
        } else {
            $this->RetrievePaymentMethodsFeesRequest = $retrievePaymentMethodsFeesRequest;
        }
        return $this;
    }
    /**
     * Get PaymentMethodTypes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getPaymentMethodTypes()
    {
        return isset($this->PaymentMethodTypes) ? $this->PaymentMethodTypes : null;
    }
    /**
     * Set PaymentMethodTypes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $paymentMethodTypes
     * @return \StructType\RetrievePaymentMethodsFees
     */
    public function setPaymentMethodTypes(\ArrayType\ArrayOfstring $paymentMethodTypes = null)
    {
        if (is_null($paymentMethodTypes) || (is_array($paymentMethodTypes) && empty($paymentMethodTypes))) {
            unset($this->PaymentMethodTypes);
        } else {
            $this->PaymentMethodTypes = $paymentMethodTypes;
        }
        return $this;
    }
    /**
     * Get PaymentMethods value
     * @return \ArrayType\ArrayOfEnumerations_PaymentMethodTypes|null
     */
    public function getPaymentMethods()
    {
        return $this->PaymentMethods;
    }
    /**
     * Set PaymentMethods value
     * @param \ArrayType\ArrayOfEnumerations_PaymentMethodTypes $paymentMethods
     * @return \StructType\RetrievePaymentMethodsFees
     */
    public function setPaymentMethods(\ArrayType\ArrayOfEnumerations_PaymentMethodTypes $paymentMethods = null)
    {
        $this->PaymentMethods = $paymentMethods;
        return $this;
    }
}
